'###################################
'######### Sterowana dioda #########
'###################################


$regfile = "attiny13.dat"

Dim Opoznienie As Byte , Opoznienie1 As Word , Pomoc As Byte , Licznik As Byte , Swiec As Word , Zgas As Word
Dim Pomoc1 As Byte , Pozwol As Word , Koniec As Byte
Dim Startt_s As Byte , Startt_p As Byte
Dim Czas_przerw As Word , Czas_swiec As Word , Syg_zas As Byte
Dim Wlacz As Byte , Wstrzymaj As Word , Dalej As Byte , A As Byte


Config Portb = &B11111                            'wszystkie kocwki jako wyjcia
        Portb = &B00101


Config Timer0 = Timer , Prescale = 256            'zwikszanie T/C1 co 53us (256*0,21us)
Enable Interrupts : Enable Timer0 : On Timer0 Co53us

Pozwol = 1
Koniec = 1


Do
Loop


Co53us:
Timer0 = 69                                       'obsu przerwanie co okoo 0,01s (100Hz)

'SYGNALIZACJA WCZENIA ZASILANIA
      Incr Syg_zas                                'odliczaj czas
      If Syg_zas = 100 Then                       'gdy dojdzie do 5 to wyzeruj
         Syg_zas = 0
         Portb.2 = 0                              'wycz diod
      End If

'OBSUGA PRZYCISKU
If Pinb.0 = 0 And Pozwol = 1 And Koniec = 1 Then  'gdy nacinity przycisk
   Incr Opoznienie                                'zwiksz zawarto zmiennej opoznienie
   If Opoznienie = 20 Then                        'gdy zliczy do 20 to wyzeruj
      Opoznienie = 0                              'i zwiksz zawarto licznika
      Incr Licznik                                'o jeden w gre
      If Licznik = 5 Then                         'gdy dojdzie do 5 to wyzeruj
         Licznik = 0
End If
   End If
      End If


If Pinb.0 = 0 And Opoznienie = 0 Then             'aby zmienn Licznik zwieksza tylko o 1 to po kadym wyzerowaniu zmiennej
   Koniec = 0                                     'Opoznienie blokujemy mozliwo dalszych zmian
Else                                              'gdy przycisk zwolniony
   Koniec = 1                                     'ustawiamy zmienn Koniec aby mc zmieni kolejny raz warto licznika
End If

If Pinb.0 = 0 Then                                'po naciniciu przycisku
   Portb.1 = 1                                    'zapalaj diod
Else                                              'gdy przycisk zwolniony
   Portb.1 = 0                                    'wyczaj diod
End If

Select Case Licznik                               'w zalenoci od wartoci zmiennej Licznik wykonuj odpowiednie polecenia
Case 0:                                           'najpierw
   Pozwol = 1                                     'ustaw zmienn pozwl

Case 1:                                           'nastpnie
   Wlacz = 0                                      'wylacz miganie diody

Case 2:                                           'gdy licznik = 2
   Pomoc = 1                                      'ustaw odpowiednio zmienne
   Pomoc1 = 1                                     'i wyzeruj zmienne, ktre odliczaj czas
   Swiec = 0
   Zgas = 0
   Czas_swiec = 0
   Czas_przerw = 0

Case 3:                                           'gdy licznik = 3
If Pinb.0 = 0 Then                                'i wcinity przycisk
   Startt_s = 1                                   'wcza odliczanie czasu (czas trzymania przycisku)
Else                                              'w przeciwnym wypadku
   Startt_s = 0                                   'zatrzymaj zliczanie czasu
End If

If Startt_s = 1 Then                              'gdy ustawiona zmienna Startt_s
   Incr Czas_swiec                                'zwiksz zawarto zmiennej
   If Czas_swiec = 20000 Then                     'zlicza do okoo 20 sekund
      Czas_swiec = 0                              'po przepenieniu licznika zeruje i liczy od nowa
End If
   End If

If Pinb.0 = 1 Then                                'gdy po naciniciu przycisku i puszczeniu
   Startt_p = 1                                   'wcz odliczanie czasu przerwy pomidzy naciniciami
End If

If Startt_p = 1 Then                              'odliczaj czas przerwy
   Incr Czas_przerw
   If Czas_przerw = 20000 Then
      Czas_przerw = 0
End If
   End If

Case 4:                                           'ponowne nacinicie przycisku
Pozwol = 0                                        'zeruje zmienn pomoc
   Startt_p = 0                                   'zatrzymyje odliczanie czasu przerwy
   Wlacz = 1                                      'wcza sygnalizacj (diod)

   Incr Wstrzymaj
   If Wstrzymaj = 400 Then
      Wstrzymaj = 0
      Licznik = 0
   End If
End Select


If Wlacz = 1 And Pomoc = 1 Then
Incr Swiec
If Swiec = Czas_swiec Then
   Swiec = 0
   Pomoc = 0
   Pomoc1 = 1
End If
   End If

   If Swiec > 0 And Swiec < Czas_swiec Then
      Portb.1 = 1
   End If

If Pomoc = 0 And Pomoc1 = 1 Then
Incr Zgas
If Zgas = Czas_przerw Then
   Zgas = 0
   Pomoc1 = 0
   Pomoc = 1
End If
   End If

   If Zgas > 0 And Zgas < Czas_przerw Then
      Portb.1 = 0
   End If

Return